diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
index 5b20fdef6..de37cda71 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
@@ -13,6 +13,7 @@ import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -36,13 +37,13 @@ public class TileEntityActivator extends TileEntity implements Container {
     }
 
     @Override
-    public ItemStack getItem(int index)
+    public @Nullable ItemStack getItem(int index)
     {
         return dispenserContents[index];
     }
 
     @Override
-    public ItemStack removeItem(int index, int takeAmount)
+    public @Nullable ItemStack removeItem(int index, int takeAmount)
     {
         if(dispenserContents[index] != null)
         {
@@ -119,7 +120,7 @@ public class TileEntityActivator extends TileEntity implements Container {
     }
 
     @Override
-    public void setItem(int index, ItemStack itemstack)
+    public void setItem(int index, @Nullable ItemStack itemstack)
     {
         dispenserContents[index] = itemstack;
         if(itemstack != null && itemstack.stackSize > getMaxStackSize())
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
index e1555e48e..162af9669 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
@@ -15,6 +15,7 @@ import net.minecraft.core.player.inventory.InventorySorter;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 public class TileEntityChest extends TileEntity
@@ -34,13 +35,13 @@ public class TileEntityChest extends TileEntity
     }
 
     @Override
-	public ItemStack getItem(int index)
+	public @Nullable ItemStack getItem(int index)
     {
         return chestContents[index];
     }
 
     @Override
-	public ItemStack removeItem(int index, int takeAmount)
+	public @Nullable ItemStack removeItem(int index, int takeAmount)
     {
         if(chestContents[index] != null)
         {
@@ -65,7 +66,7 @@ public class TileEntityChest extends TileEntity
     }
 
     @Override
-	public void setItem(int index, ItemStack itemstack)
+	public void setItem(int index, @Nullable ItemStack itemstack)
     {
         chestContents[index] = itemstack;
         if(itemstack != null && itemstack.stackSize > getMaxStackSize())
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
index d36da668a..02491e749 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
@@ -14,6 +14,7 @@ import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -34,13 +35,13 @@ public class TileEntityDispenser extends TileEntity
     }
 
     @Override
-	public ItemStack getItem(int index)
+	public @Nullable ItemStack getItem(int index)
     {
         return dispenserContents[index];
     }
 
     @Override
-	public ItemStack removeItem(int index, int takeAmount)
+	public @Nullable ItemStack removeItem(int index, int takeAmount)
     {
         if(dispenserContents[index] != null)
         {
@@ -96,7 +97,7 @@ public class TileEntityDispenser extends TileEntity
     }
 
     @Override
-	public void setItem(int index, ItemStack itemstack)
+	public void setItem(int index, @Nullable ItemStack itemstack)
     {
         dispenserContents[index] = itemstack;
         if(itemstack != null && itemstack.stackSize > getMaxStackSize())
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
index 9aab9595a..21a1e1195 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
@@ -186,7 +186,7 @@ public class TileEntityFlag extends TileEntity
     }
 
     @Override
-    public ItemStack getItem(int index) {
+    public @Nullable ItemStack getItem(int index) {
         index -= 36;
         if (index < 0 || index >= 3) return null;
         
@@ -194,7 +194,7 @@ public class TileEntityFlag extends TileEntity
     }
 
     @Override
-    public ItemStack removeItem(int index, int takeAmount) {
+    public @Nullable ItemStack removeItem(int index, int takeAmount) {
         index -= 36;
         if (items[index] != null)
         {
@@ -230,7 +230,7 @@ public class TileEntityFlag extends TileEntity
     }
 
     @Override
-    public void setItem(int index, ItemStack stack)
+    public void setItem(int index, @Nullable ItemStack stack)
     {
         index -= 36; // This seems so wrong and will almost certainly cause an issue at some point
         items[index] = stack;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
index 2793f0879..943dbdf37 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
@@ -20,6 +20,7 @@ import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.List;
 import java.util.Random;
@@ -46,13 +47,13 @@ public class TileEntityFurnace extends TileEntity
     }
 
     @Override
-	public ItemStack getItem(int index)
+	public @Nullable ItemStack getItem(int index)
     {
         return furnaceItemStacks[index];
     }
 
     @Override
-	public ItemStack removeItem(int index, int takeAmount)
+	public @Nullable ItemStack removeItem(int index, int takeAmount)
     {
         if(furnaceItemStacks[index] != null)
         {
@@ -81,7 +82,7 @@ public class TileEntityFurnace extends TileEntity
     }
 
     @Override
-	public void setItem(int index, ItemStack itemstack)
+	public void setItem(int index, @Nullable ItemStack itemstack)
     {
         furnaceItemStacks[index] = itemstack;
         if(itemstack != null && itemstack.stackSize > getMaxStackSize())
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
index dbab2da7e..1fceada04 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
@@ -57,13 +57,13 @@ public class TileEntityTrommel extends TileEntity
     }
 
     @Override
-	public ItemStack getItem(int index)
+	public @Nullable ItemStack getItem(int index)
     {
         return itemStacks[index];
     }
 
     @Override
-	public ItemStack removeItem(int index, int takeAmount)
+	public @Nullable ItemStack removeItem(int index, int takeAmount)
     {
         if(itemStacks[index] != null)
         {
@@ -86,7 +86,7 @@ public class TileEntityTrommel extends TileEntity
     }
 
     @Override
-	public void setItem(int index, ItemStack itemstack)
+	public void setItem(int index, @Nullable ItemStack itemstack)
     {
         itemStacks[index] = itemstack;
         if(itemstack != null && itemstack.stackSize > getMaxStackSize())
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
index 8d031144e..cd1757f62 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
@@ -24,11 +24,13 @@ public class BlockLogicPistonHead extends BlockLogic
     public static final int TYPE_STEEL = 2;
 
     private final double headThickness;
-    public BlockLogicPistonHead(Block<?> block, double headThickness)
+    private final double shaftThickness;
+    public BlockLogicPistonHead(final Block<?> block, final double headThickness, final double shaftThickness)
     {
         super(block, Material.piston);
         block.withHardness(0.5F);
         this.headThickness = headThickness;
+        this.shaftThickness = shaftThickness;
     }
 
     @Override
@@ -80,33 +82,33 @@ public class BlockLogicPistonHead extends BlockLogic
     }
 
     @Override
-    public void getCollidingBoundingBoxes(World world, int x, int y, int z, AABB aabb, ArrayList<AABB> aabbList)
+    public void getCollidingBoundingBoxes(final World world, final int x, final int y, final int z, final AABB aabb, final ArrayList<AABB> aabbList)
     {
         switch(getDirectionFromMeta(world.getBlockMetadata(x, y, z)))
         {
             case DOWN:
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, headThickness, 1.0F).move(x, y, z), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.375F, headThickness, 0.375F, 0.625F, 1 + headThickness, 0.625F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, this.headThickness, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.5 - this.shaftThickness/2, this.headThickness, 0.5 - this.shaftThickness/2, 0.5 + this.shaftThickness/2, 1 + this.headThickness, 0.5 + this.shaftThickness/2).move(x, y, z), aabbList);
                 break;
             case UP:
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 1 - headThickness, 0.0F, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.375F, -headThickness, 0.375F, 0.625F, 1 - headThickness, 0.625F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 1 - this.headThickness, 0.0F, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.5 - this.shaftThickness/2, -this.headThickness, 0.5 - this.shaftThickness/2, 0.5 + this.shaftThickness/2, 1 - this.headThickness, 0.5 + this.shaftThickness/2).move(x, y, z), aabbList);
                 break;
             case NORTH:
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, headThickness).move(x, y, z), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(headThickness, 0.375F, headThickness, 1 - headThickness, 0.625F, 1 + headThickness).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, this.headThickness).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.5 - this.shaftThickness/2, 0.5 - this.shaftThickness/2, this.headThickness, 0.5 + this.shaftThickness/2, 0.5 + this.shaftThickness/2, 1 + this.headThickness).move(x, y, z), aabbList);
                 break;
             case SOUTH:
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(headThickness, 0.375F, -headThickness, 1 - headThickness, 0.625F, 1 - headThickness).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 1 - this.headThickness, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.5 - this.shaftThickness/2, 0.5 - this.shaftThickness/2, -this.headThickness, 0.5 + this.shaftThickness/2, 0.5 + this.shaftThickness/2, 1 - this.headThickness).move(x, y, z), aabbList);
                 break;
             case WEST:
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, headThickness, 1.0F, 1.0F).move(x, y, z), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(headThickness, 0.375F, headThickness, 1 + headThickness, 0.625F, 1 - headThickness).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, this.headThickness, 1.0F, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(this.headThickness, 0.5 - this.shaftThickness/2, 0.5 - this.shaftThickness/2, 1 + this.headThickness, 0.5 + this.shaftThickness/2, 0.5 + this.shaftThickness/2).move(x, y, z), aabbList);
                 break;
             case EAST:
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(1 - headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(-headThickness, 0.375F, headThickness, 1 - headThickness, 0.625F, 1 - headThickness).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(1 - this.headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(-this.headThickness, 0.5 - this.shaftThickness/2, 0.5 - this.shaftThickness/2, 1 - this.headThickness, 0.5 + this.shaftThickness/2, 0.5 + this.shaftThickness/2).move(x, y, z), aabbList);
                 break;
         }
     }
@@ -118,17 +120,17 @@ public class BlockLogicPistonHead extends BlockLogic
         switch(getDirectionFromMeta(l))
         {
             case DOWN:
-                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, headThickness, 1.0F);
+                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, this.headThickness, 1.0F);
             case UP:
-                return AABB.getTemporaryBB(0.0F, 1 - headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
+                return AABB.getTemporaryBB(0.0F, 1 - this.headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
             case NORTH:
-                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, headThickness);
+                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, this.headThickness);
             case SOUTH:
-                return AABB.getTemporaryBB(0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F, 1.0F);
+                return AABB.getTemporaryBB(0.0F, 0.0F, 1 - this.headThickness, 1.0F, 1.0F, 1.0F);
             case WEST:
-                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, headThickness, 1.0F, 1.0F);
+                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, this.headThickness, 1.0F, 1.0F);
             case EAST:
-                return AABB.getTemporaryBB(1 - headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+                return AABB.getTemporaryBB(1 - this.headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         }
         return super.getBlockBoundsFromState(world, x, y, z);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index a01d44a32..fa2f5ad7f 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -1250,7 +1250,7 @@ public abstract class Entity
 
         entityRiderYawDelta -= yaw;
         //entityRiderPitchDelta -= pitch;
-        if(turnWithVehicle && false) yRot += yaw;
+        if(turnWithVehicle) yRot += yaw;
         //rotationPitch += pitch;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index 8b8c47d2f..f7d6a20ad 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -543,7 +543,9 @@ public abstract class Mob extends Entity
             prevBonusHealth = bonusHealth;
             heartsFlashTime = heartsHalvesLife;
             damageEntity(damage, type);
-            hurtTime = maxHurtTime = 10;
+            if (damage > 0) {
+                hurtTime = maxHurtTime = 10;
+            }
         }
         attackedAtYaw = 0.0F;
         if(flag)
@@ -575,7 +577,7 @@ public abstract class Mob extends Entity
             }
             onDeath(attacker);
         } else
-        if(flag)
+        if(flag && damage > 0)
         {
         	playHurtSound();
         }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
index fa8145cbe..c0d278226 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
@@ -4,7 +4,6 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.IItemHolding;
 import net.minecraft.core.entity.Mob;
-import net.minecraft.core.entity.MobPathfinder;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.ProjectileArrow;
 import net.minecraft.core.item.ItemFood;
@@ -313,15 +312,15 @@ public class MobWolf extends MobAnimal implements IItemHolding
             setTarget(null);
         }
 
-        if(!hasAttacked && !hasPath() && isWolfTamed() && vehicle == null)
+        if(!this.hasAttacked && !hasPath() && isWolfTamed() && this.vehicle == null)
         {
-            Player entityplayer = world.getPlayerEntityByUUID(getWolfOwner());
-            if(entityplayer != null)
+            final Player owner = this.world.getPlayerEntityByUUID(getWolfOwner());
+            if(owner != null)
             {
-                float f = entityplayer.distanceTo(this);
-                if(f > 5F)
+                final float ownerDistance = owner.distanceTo(this);
+                if(ownerDistance > 5F)
                 {
-                    getPathOrWalkableBlock(entityplayer, f);
+                    setPathToOwnerOrTeleport(owner, ownerDistance);
                 }
             } else
             if(isInWater())
@@ -531,21 +530,27 @@ public class MobWolf extends MobAnimal implements IItemHolding
         }
     }
 
-    private void getPathOrWalkableBlock(Entity entity, float f)
+    private void setPathToOwnerOrTeleport(final Entity owner, final float distance)
     {
-        Path pathentity = world.getPathToEntity(this, entity, 16F);
-        if(pathentity == null && f > 12F)
+        final Path path = this.world.getPathToEntity(this, owner, 16F);
+        if(path == null && distance > 12F)
         {
-            int i = MathHelper.floor(entity.x) - 2;
-            int j = MathHelper.floor(entity.z) - 2;
-            int k = MathHelper.floor(entity.bb.minY);
-            for(int l = 0; l <= 4; l++)
+            final int targetX = MathHelper.floor(owner.x);
+            final int targetY = MathHelper.floor(owner.bb.minY);
+            final int targetZ = MathHelper.floor(owner.z);
+            final byte searchRadius = 2;
+            for(int _x = -searchRadius; _x <= searchRadius; _x++)
             {
-                for(int i1 = 0; i1 <= 4; i1++)
+                for(int _z = -searchRadius; _z <= searchRadius; _z++)
                 {
-                    if((l < 1 || i1 < 1 || l > 3 || i1 > 3) && world.isBlockNormalCube(i + l, k - 1, j + i1) && !world.isBlockNormalCube(i + l, k, j + i1) && !world.isBlockNormalCube(i + l, k + 1, j + i1))
+                    if(
+                        (Math.abs(_x) > 1 || Math.abs(_z) > 1) &&  // forbid teleports within a 1 block radius of the player
+                            this.world.isBlockNormalCube(targetX + _x, targetY - 1, targetZ + _z) && // Solid floor
+                            !this.world.isBlockNormalCube(targetX + _x, targetY, targetZ + _z) && // Two blocks of clearance
+                            !this.world.isBlockNormalCube(targetX + _x, targetY + 1, targetZ + _z))
                     {
-                        moveTo((float)(i + l) + 0.5F, k, (float)(j + i1) + 0.5F, yRot, xRot);
+                        moveTo(targetX + _x + 0.5F, targetY, targetZ + _z + 0.5F, this.yRot, this.xRot);
+                        this.fallDistance = 0;
                         return;
                     }
                 }
@@ -554,7 +559,7 @@ public class MobWolf extends MobAnimal implements IItemHolding
 
         } else
         {
-            setPathToEntity(pathentity);
+            setPathToEntity(path);
         }
     }
 
@@ -637,7 +642,7 @@ public class MobWolf extends MobAnimal implements IItemHolding
     @Override
 	protected void attackEntity(@NotNull Entity entity, float distance)
     {
-        if(entity instanceof EntityItem)
+        if(entity instanceof EntityItem || entity == world.getPlayerEntityByUUID(getWolfOwner()))
             return;
         if(distance > 2.0F && distance < 6F && random.nextInt(10) == 0)
         {
@@ -850,7 +855,7 @@ public class MobWolf extends MobAnimal implements IItemHolding
         }
     }
 
-    public UUID getWolfOwner()
+    public @Nullable UUID getWolfOwner()
     {
         return entityData.getUUID(DATA_OWNER_UUID);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
index 5bec715fd..da5eb2dac 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.entity.monster;
 
 import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.MobFlying;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.ProjectileFireball;
@@ -277,7 +278,11 @@ public class MobGhast extends MobFlying
     @Override
 	public boolean canSpawnHere()
     {
-        return random.nextInt(20) == 0 && super.canSpawnHere() && world.getDifficulty().canHostileMobsSpawn();
+        return
+            this.world.getDifficulty().canHostileMobsSpawn() &&
+            this.random.nextInt(20) == 0 &&
+            BlockTags.NETHER_MOBS_SPAWN.appliesTo(this.world.getBlock(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z))) &&
+            super.canSpawnHere();
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
index b821ac823..0f1c5c588 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
@@ -143,7 +143,7 @@ public class EntityMinecart extends Entity implements Container {
     public void setMeta(int meta) {entityData.set(DATA_META, meta);}
     public int getMeta() {return entityData.getInt(DATA_META);}
 
-    public void setFuel(int fuel) {entityData.set(DATA_FUEL, fuel);}
+    public void setFuel(short fuel) {entityData.set(DATA_FUEL, fuel);}
     public short getFuel() {return entityData.getShort(DATA_FUEL);}
 
 
@@ -273,6 +273,7 @@ public class EntityMinecart extends Entity implements Container {
             pushTime = 0;
         }
 
+
         double _xo = x;
         double _yo = y;
         double _zo = z;
@@ -292,33 +293,8 @@ public class EntityMinecart extends Entity implements Container {
                 setRot(yRot, xRot);
             }
         } else {
-            yd -= 0.08D;
             motionIteration();
             motionIteration();
-
-            int blockX = MathHelper.floor(x);
-            int blockY = MathHelper.floor(y);
-            int blockZ = MathHelper.floor(z);
-            Block<?> block = world.getBlock(blockX, blockY, blockZ);
-            if (block == null || !(block.getLogic() instanceof BlockLogicRail)) {
-                double motionScale = 1;
-
-                if(onGround) {
-                    motionScale = 0.546F;
-                    if(block != null)
-                    {
-                        motionScale = block.friction * 0.91F;
-                    }
-                } else {
-                    motionScale = 0.99;
-                    motionScale = MathHelper.lerp(motionScale, 1f, pushTime);
-                }
-
-                xd *= motionScale;
-                zd *= motionScale;
-
-                move(xd, yd, zd);
-            }
         }
         this.xo = _xo;
         this.yo = _yo;
@@ -331,6 +307,7 @@ public class EntityMinecart extends Entity implements Container {
         xo = x;
         yo = y;
         zo = z;
+        yd -= 0.04D;
         int blockX = MathHelper.floor(x);
         int blockY = MathHelper.floor(y);
         int blockZ = MathHelper.floor(z);
@@ -505,6 +482,21 @@ public class EntityMinecart extends Entity implements Container {
                     }
                 }
             }
+        } else {
+            xd = MathHelper.clamp(xd, -maxSpeed, maxSpeed);
+            zd = MathHelper.clamp(zd, -maxSpeed, maxSpeed);
+
+            if(onGround) {
+                xd *= 0.5D;
+                yd *= 0.5D;
+                zd *= 0.5D;
+            }
+            move(xd, yd, zd);
+            if(!onGround) {
+                xd *= 0.95D;
+                yd *= 0.95D;
+                zd *= 0.95D;
+            }
         }
         xRot = 0.0F;
         double diffX = xo - x;
@@ -537,7 +529,7 @@ public class EntityMinecart extends Entity implements Container {
             passenger = null;
         }
         if(didFurnacePush && random.nextInt(4) == 0) {
-            setFuel(getFuel() - 1);
+            setFuel((short) (getFuel() - 1));
             if(getFuel() < 0) {
                 xPush = 0.0D;
                 zPush = 0.0D;
@@ -792,7 +784,7 @@ public class EntityMinecart extends Entity implements Container {
                     {
                         player.inventory.setItem(player.inventory.getCurrentItemIndex(), null);
                     }
-                    setFuel(getFuel() + (int) ((LookupFuelFurnace.instance.getFuelYield(itemstack.itemID)/1600F) * 1200));
+                    setFuel((short) (getFuel() + ((LookupFuelFurnace.instance.getFuelYield(itemstack.itemID)/1600F) * 1200)));
                 }
                 xPush = x - player.x;
                 zPush = z - player.z;
@@ -866,12 +858,12 @@ public class EntityMinecart extends Entity implements Container {
     }
 
     @Override
-    public ItemStack getItem(int index) {
+    public @Nullable ItemStack getItem(int index) {
         return items[index];
     }
 
     @Override
-    public ItemStack removeItem(int index, int takeAmount) {
+    public @Nullable ItemStack removeItem(int index, int takeAmount) {
         if(items[index] != null) {
             if(items[index].stackSize <= takeAmount) {
                 ItemStack itemstack = items[index];
@@ -889,7 +881,7 @@ public class EntityMinecart extends Entity implements Container {
     }
 
     @Override
-    public void setItem(int index, ItemStack itemstack) {
+    public void setItem(int index, @Nullable ItemStack itemstack) {
         items[index] = itemstack;
         if(itemstack != null && itemstack.stackSize > getMaxStackSize()) {
             itemstack.stackSize = getMaxStackSize();
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSeed.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSeed.java
index 7e248a3c4..feff7ecb5 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSeed.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSeed.java
@@ -3,6 +3,7 @@ package net.minecraft.core.net.command.commands;
 import com.mojang.brigadier.Command;
 import com.mojang.brigadier.CommandDispatcher;
 import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import net.minecraft.core.Global;
 import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 
@@ -18,15 +19,8 @@ public class CommandSeed implements CommandManager.CommandRegistry {
                     CommandSource source = c.getSource();
                     source.sendTranslatableMessage("command.commands.seed.success", source.getWorld().getRandomSeed());
                     if (source.getSender() != null) {
-                        Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
-                        if (clipboard != null) {
-                            try {
-                                clipboard.setContents(new StringSelection(String.valueOf(source.getWorld().getRandomSeed())), null);
-                                source.sendTranslatableMessage("command.commands.seed.copied_to_clipboard");
-                            } catch (Exception ignored) {
-
-                            }
-                        }
+                        Global.accessor.copyToClipboard(Long.toString(source.getWorld().getRandomSeed()));
+                        source.sendTranslatableMessage("command.commands.seed.copied_to_clipboard");
                     }
                     return Command.SINGLE_SUCCESS;
                 })
